# El módulo en python para un nodos de un árbol de búsqueda binario.
# Y algunas operaciones en él
#
# Fraga 05.11.2021
# Fraga 08.11.2021

class Nodo :
	def __init__( self, llave ) : 
		self.llave = llave 
		self.izq = None
		self.der = None
		self.p = None

	def imprime( self ) :
		print( self.llave, end=' ' )

def camina_en_orden( a ) :
	if a is not None :
		camina_en_orden( a.izq )
		a.imprime( )
		camina_en_orden( a.der )

def busca_minimo( x ) :	
	while x.izq is not None :
		x = x.izq
	return x

def busca_maximo( x ) :	
	while x.der is not None :
		x = x.der
	return x

def sucesor( x ) :
	if x.der is not None :
		return busca_minimo( x.der )
	y = x.p
	while y is not None and x == y.der :
		x = y
		y = y.p
	return y

